import React, { useState, useCallback } from 'react';
import ReactDOM from 'react-dom';

const width = 960;
const height = 500;
const circleRadius = 30;
const initialMousePosition = {x: width/2, y:height/2};


const App = () => {
  const [mousePosition, setMousePosition] = useState(initialMousePosition);
  const MouseMoveHandler = useCallback(event => {
  	const { clientX, clientY } = event;
  	setMousePosition({ x: clientX, y: clientY });
	}, [setMousePosition]); // 2nd arg: list of dependencies that the function needs in order to run

  return (
    <svg width={width} height={height} onMouseMove={MouseMoveHandler}>
      <circle
        cx={mousePosition.x}
        cy={mousePosition.y}
        r={circleRadius}
      />
    </svg>
  );
};

const rootElement = document.getElementById("root");
ReactDOM.render(<App />, rootElement);
